package org.ow2.odis.mock;

import java.util.Observable;

import org.ow2.odis.connection.IConnectionOut;
import org.ow2.odis.connection.context.ContextMessage;
import org.ow2.odis.connection.context.IContextualConnectionOut;
import org.ow2.odis.exception.OdisConnectionException;
import org.ow2.odis.lifeCycle.connection.AbstractConnectionState;
import org.ow2.odis.lifeCycle.connection.StateConnectionLoaded;
import org.ow2.odis.model.AbstractConnectionAttribute;


/**
 * @author mobo7205
 */
public class MockConnexionOut implements IContextualConnectionOut, IConnectionOut {
    AbstractConnectionState state = new StateConnectionLoaded();

    final AbstractConnectionAttribute attribute;

    private byte[] msg = null;

    private ContextMessage contextMsg = null;
    
    private int nbContextMsgSent = 0;
    
    private int nbMsgSent = 0;
    
    public MockConnexionOut(AbstractConnectionAttribute attribute) {
        this.attribute = attribute;
    }

    public boolean send(ContextMessage msg) {
        this.contextMsg = msg;
        this.nbContextMsgSent++;
        return true;
    }

    public void usedAsTwoWay() {
    }

    public boolean send(byte[] msg) {
    	this.msg = msg;
    	this.nbMsgSent++;
        return true;
    }

    public AbstractConnectionAttribute getAttribute() {
        return attribute;
    }

    public AbstractConnectionState getConnectionState() {
        return state;
    }

    public void initComponent() throws OdisConnectionException {
    }

    public void launchComponent() throws OdisConnectionException {
    }

    public void setConnectionState(AbstractConnectionState state) {
        this.state = state;
    }

    public void stopComponent() {
    }

    public void unloadComponent() {
    }

    public void update(Observable arg0, Object arg1) {
    }

    public AbstractConnectionState getState() {
        return state;
    }

    public void setState(AbstractConnectionState state) {
        this.state = state;
    }

	public byte[] getMsg() {
		return msg;
	}

	public void setMsg(byte[] msg) {
		this.msg = msg;
	}

	public ContextMessage getContextMsg() {
		return contextMsg;
	}

	public void setContextMsg(ContextMessage contextMsg) {
		this.contextMsg = contextMsg;
	}

	public int getNbContextMsgSent() {
		return nbContextMsgSent;
	}

	public void setNbContextMsgSent(int nbContextMsgSent) {
		this.nbContextMsgSent = nbContextMsgSent;
	}

	public int getNbMsgSent() {
		return nbMsgSent;
	}

	public void setNbMsgSent(int nbMsgSent) {
		this.nbMsgSent = nbMsgSent;
	}
}
