package org.ow2.odis.test;

import java.util.ArrayList;
import java.util.List;

import org.objectweb.util.monolog.Monolog;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;
import org.ow2.odis.engine.FWEvent;
import org.ow2.odis.engine.IProceed;
import org.ow2.odis.routing.IRouting;
import org.ow2.odis.routing.RoutingObject;
import org.ow2.odis.routing.RoutingObjectFactory;
import org.ow2.odis.testModel.Tension;

/**
 * The Class ProceedRouting.
 */
public class ProceedRouting implements IProceed, IRouting {
    /** The ls routing. */
    static List lsRouting = null;

    /** The i. */
    static long i = 0;

    /** The factory. */
    RoutingObjectFactory factory = null;

    /** The Constant LOGGER. */
    static final Logger LOGGER = Monolog.initialize().getLogger(ProceedRouting.class.getName());

    /** The consumable classes. */
    private final String[] consumableClasses = {};

    /** The generated classes. */
    private final String[] generatedClasses = { Tension.class.getName() };

    /**
     * Instantiates a new proceed routing.
     */
    public ProceedRouting() {
        factory = new RoutingObjectFactory(this);
        LOGGER.log(BasicLevel.DEBUG, "create ProceedRouting");
    }

    /**
     * Proceed.
     * @param obj the obj
     * @return the list
     * @see com.francetelecom.odis.component.engine.IProceed#proceed(java.lang.Object)
     */
    public List proceed(Object obj) {
        LOGGER.log(BasicLevel.DEBUG, "proceed with routing");
        List result = new ArrayList();
        RoutingObject ro = factory.newRoutingObject();
        Tension tension = new Tension();
        double value = Math.random() * 100;
        tension.setValue((int) Math.round(value));
        tension.setId(i++);
        tension.setTelephone("");
        tension.setTime(0);
        ro.setPayload(tension);
        ro.clearDestination();
        if (value < 30) {
            ro.addDestination("medecin");
            LOGGER.log(BasicLevel.DEBUG, "add medecin destination");
        }
        if (value < 70) {
            ro.addDestination("poubelle");
            LOGGER.log(BasicLevel.DEBUG, "add medecin destination");
        } else {
            LOGGER.log(BasicLevel.DEBUG, "no destination");
        }
        // resolve the indirection of routing
        result.add(ro);
        return result;
    }

    /**
     * Init.
     * @param value the value
     * @return true, if init
     * @see com.francetelecom.odis.component.engine.IProceed#init(java.lang.String)
     */
    public boolean init(String value) {
        return true;
    }

    /**
     * Close.
     * @see com.francetelecom.odis.component.engine.IProceed#close()
     */
    public void close() {
    }

    /**
     * @param event
     * @see com.francetelecom.odis.component.engine.IProceed#notifyFWEvent(com.francetelecom.odis.component.engine.FWEvent)
     */
    public void notifyFWEvent(FWEvent event) {
    }

    /**
     * Gets the ls destinations.
     * @return the ls destinations
     * @see com.francetelecom.odis.component.routing.IRouting#getLsDestinations()
     */
    public List getLsDestinations() {
        if (lsRouting == null) {
            lsRouting = new ArrayList();
            lsRouting.add("medecin");
            lsRouting.add("poubelle");
        }
        return lsRouting;
    }

    /**
     * Gets the consumable classes.
     * @return the consumable classes
     */
    public String[] getConsumableClasses() {
        return consumableClasses;
    }

    /**
     * Gets the generate classes.
     * @return the generate classes
     */
    public String[] getGenerateClasses() {
        return generatedClasses;
    }
}
