package org.ow2.odis.test;

import java.util.ArrayList;
import java.util.List;

import org.objectweb.util.monolog.Monolog;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;
import org.ow2.odis.engine.FWEvent;
import org.ow2.odis.engine.IProceed;
import org.ow2.odis.testModel.TensionOdd;

/**
 * The Class ProcessGenerateTensionOdd.
 */
public class ProcessGenerateTensionOdd implements IProceed {
    // ----------------------------------------------------------------------------------------
    // attributes
    // ----------------------------------------------------------------------------------------
    /** The Constant LOGGER. */
    private final static Logger LOGGER = Monolog.initialize().getLogger(ProcessGenerateTensionOdd.class.getName());

    /** The j. */
    private long j = 0;

    /** The consummable classes. */
    private final String[] consummableClasses = {};

    /** The generated classes. */
    private final String[] generatedClasses = { TensionOdd.class.getName() };

    // ----------------------------------------------------------------------------------------
    // methodes
    // ----------------------------------------------------------------------------------------
    /**
     * Proceed.
     * @param obj the obj
     * @return the list
     * @see com.francetelecom.odis.component.engine.IProceed#proceed(java.lang.Object)
     */
    public List proceed(Object obj) {
        LOGGER.log(BasicLevel.DEBUG, "Generate 10 new tension");
        List result = new ArrayList();
        for (int i = 0; i < 10; i++) {
            j++;
            TensionOdd t = new TensionOdd();
            t.setId((j * 2) + 1);
            t.setTime(System.currentTimeMillis());
            t.setTelephone("O445454557");
            t.setValue(456);
            LOGGER.log(BasicLevel.INFO, "   => tension (" + i + ")" + t);
            result.add(t);
        }
        return result;
    }

    /**
     * Init.
     * @param value the value
     * @return true, if init
     * @see com.francetelecom.odis.component.engine.IProceed#init(java.lang.String)
     */
    public boolean init(String value) {
        return true;
    }

    /**
     * Close.
     * @see com.francetelecom.odis.component.engine.IProceed#close()
     */
    public void close() {
    }

    /**
     * Notify FW event.
     * @param event the event
     * @see com.francetelecom.odis.component.engine.IProceed#notifyFWEvent(com.francetelecom.odis.component.engine.FWEvent)
     */
    public void notifyFWEvent(FWEvent event) {
    }

    /**
     * Gets the consumable classes.
     * @return the consumable classes
     */
    public String[] getConsumableClasses() {
        return consummableClasses;
    }

    /**
     * Gets the generate classes.
     * @return the generate classes
     */
    public String[] getGenerateClasses() {
        return generatedClasses;
    }
}
