package org.ow2.odis.test;

import java.util.List;

import org.objectweb.util.monolog.Monolog;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;
import org.ow2.odis.engine.FWEvent;
import org.ow2.odis.engine.IProceed;
import org.ow2.odis.testModel.Tension;
import org.ow2.odis.testModel.TensionOdd;
import org.ow2.odis.testModel.TensionPeer;

/**
 * The Class ProcessGetTension.
 */
public class ProcessGetTension implements IProceed {
    // ----------------------------------------------------------------------------------------
    // attributes
    // ----------------------------------------------------------------------------------------
    /** The Constant LOGGER. */
    private final static Logger LOGGER = Monolog.initialize().getLogger(ProcessGetTension.class.getName());

    /** The consummable classes. */
    private final String[] consummableClasses = { Tension.class.getName() };

    /** The generated classes. */
    private final String[] generatedClasses = {};

    // ----------------------------------------------------------------------------------------
    // methodes
    // ----------------------------------------------------------------------------------------
    /**
     * Proceed.
     * @param obj the obj
     * @return the list
     * @see com.francetelecom.odis.component.engine.IProceed#proceed(java.lang.Object)
     */
    public List proceed(Object obj) {
        LOGGER.log(BasicLevel.DEBUG, "Generate 1 new tension");
        Tension t = (Tension) obj;
        LOGGER.log(BasicLevel.INFO, "   <= get tension: " + t);
        if (obj instanceof TensionOdd) {
            if ((t.getId() % 2) != 1) {
                LOGGER.log(BasicLevel.ERROR, t.getId() + " is not Odd");
            }
        }
        if (obj instanceof TensionPeer) {
            if ((t.getId() % 2) != 0) {
                LOGGER.log(BasicLevel.ERROR, t.getId() + " is not Peer");
            }
        }
        return null;
    }

    /**
     * Init.
     * @param value the value
     * @return true, if init
     * @see com.francetelecom.odis.component.engine.IProceed#init(java.lang.String)
     */
    public boolean init(String value) {
        return true;
    }

    /**
     * Close.
     * @see com.francetelecom.odis.component.engine.IProceed#close()
     */
    public void close() {
    }

    /**
     * Notify FW event.
     * @param event the event
     * @see com.francetelecom.odis.component.engine.IProceed#notifyFWEvent(com.francetelecom.odis.component.engine.FWEvent)
     */
    public void notifyFWEvent(FWEvent event) {
    }

    /**
     * Gets the consumable classes.
     * @return the consumable classes
     */
    public String[] getConsumableClasses() {
        return consummableClasses;
    }

    /**
     * Gets the generate classes.
     * @return the generate classes
     */
    public String[] getGenerateClasses() {
        return generatedClasses;
    }
}
