package org.ow2.odis.test;

import java.util.ArrayList;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;

import org.ow2.odis.engine.FWEvent;
import org.ow2.odis.engine.IProceed;

/**
 * The Class ProcessPerfInjector.
 */
public class ProcessPerfInjector extends JDialog implements IProceed {
    /** The Constant serialVersionUID. */
    private static final long serialVersionUID = 1L;

    /** The j content pane. */
    private JPanel jContentPane = null;

    /** The j button injector. */
    private JButton jButtonInjector = null;

    /** The inject. */
    private boolean inject = false;

    /** The consummable classes. */
    transient private final String[] consummableClasses = {};

    /** The generated classes. */
    transient private final String[] generatedClasses = { String.class.getName() };

    /**
     * Proceed.
     * @param obj the obj
     * @return the list
     * @see com.francetelecom.odis.component.engine.IProceed#proceed(java.lang.Object)
     */
    public List proceed(Object obj) {
        if (inject == true) {
            inject = false;
            List result = new ArrayList();
            result.add(new String("perf"));
            return result;
        }
        return null;
    }

    /**
     * Init.
     * @param value the value
     * @return true, if init
     * @see com.francetelecom.odis.component.engine.IProceed#init(java.lang.String)
     */
    public boolean init(String value) {
        this.setVisible(true);
        return true;
    }

    /**
     * @see com.francetelecom.odis.component.engine.IProceed#close()
     */
    public void close() {
        setVisible(false);
    }

    /**
     * @param event
     * @see com.francetelecom.odis.component.engine.IProceed#notifyFWEvent(com.francetelecom.odis.component.engine.FWEvent)
     */
    public void notifyFWEvent(FWEvent event) {
    }

    /**
     * This method initializes jButtonInjector.
     * @return javax.swing.JButton
     */
    private JButton getJButtonInjector() {
        if (jButtonInjector == null) {
            jButtonInjector = new JButton();
            jButtonInjector.setBounds(new java.awt.Rectangle(70, 70, 152, 44));
            jButtonInjector.setText("Inject");
            jButtonInjector.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    inject = true;
                }
            });
        }
        return jButtonInjector;
    }

    /**
     * Gets the consumable classes.
     * @return the consumable classes
     */
    public String[] getConsumableClasses() {
        return consummableClasses;
    }

    /**
     * Gets the generate classes.
     * @return the generate classes
     */
    public String[] getGenerateClasses() {
        return generatedClasses;
    }

    /**
     * This is the default constructor.
     */
    public ProcessPerfInjector() {
        super();
        initialize();
    }

    /**
     * This method initializes this.
     */
    private void initialize() {
        this.setSize(300, 200);
        this.setContentPane(getJContentPane());
    }

    /**
     * This method initializes jContentPane.
     * @return javax.swing.JPanel
     */
    private JPanel getJContentPane() {
        if (jContentPane == null) {
            jContentPane = new JPanel();
            jContentPane.setLayout(null);
            jContentPane.add(getJButtonInjector(), null);
        }
        return jContentPane;
    }
}
