package org.ow2.odis.test;

import java.util.ArrayList;
import java.util.List;

import org.objectweb.util.monolog.Monolog;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;
import org.ow2.odis.engine.FWEvent;
import org.ow2.odis.engine.IProceed;

/**
 * The Class ProcessPerfMeasure.
 */
public class ProcessPerfMeasure implements IProceed {
    /** The Constant LOGGER. */
    private final static Logger LOGGER = Monolog.initialize().getLogger(ProcessPerfMeasure.class.getName());

    /** The start. */
    private long start = -1;

    /** The count. */
    public static long count = 0;

    /** The perfs. */
    private double perfs = 0.0;

    /**
     * Proceed.
     * @param obj the obj
     * @return the list
     * @see com.francetelecom.odis.component.engine.IProceed#proceed(java.lang.Object)
     */
    public List proceed(Object obj) {
        if (start == -1) {
            start = System.currentTimeMillis();
        }
        count++;
        List result = new ArrayList();
        if ((System.currentTimeMillis() - start) != 0) {
            double nPerfs = (count * 1000) / (System.currentTimeMillis() - start);
            if (nPerfs > perfs) {
                perfs = nPerfs;
                LOGGER.log(BasicLevel.INFO, "" + perfs);
            }
        }
        return null;
    }

    /**
     * Init.
     * @param value the value
     * @return true, if init
     * @see com.francetelecom.odis.component.engine.IProceed#init(java.lang.String)
     */
    public boolean init(String value) {
        count = 0;
        return true;
    }

    /**
     * Close.
     * @see com.francetelecom.odis.component.engine.IProceed#close()
     */
    public void close() {
    }

    /**
     * Notify FW event.
     * @param event the event
     * @see com.francetelecom.odis.component.engine.IProceed#notifyFWEvent(com.francetelecom.odis.component.engine.FWEvent)
     */
    public void notifyFWEvent(FWEvent event) {
    }
}
