package org.ow2.odis.testModel;

import java.util.List;

import org.ow2.odis.domain.Domain;
import org.ow2.odis.engine.FWEvent;
import org.ow2.odis.engine.IProceed;

/**
 * This proceed is used to test dynamic configuration updates.<br>
 * The Domain is requested to add a node and a connection (always the same) at init time, then repeatedly (at each
 * cyclic timer tick) during proceed execution.
 * @author ojoh6423
 */
public class Reconfig implements IProceed {
    StringBuffer buffer = null;

    public Reconfig() {
        super();
    }

    public void close() {
        // TODO Auto-generated method stub
    }

    public boolean init(String value) {
        buffer = new StringBuffer();
        buffer.append("<odis>");
        buffer.append("<NODES>");
        buffer.append("<NODE name=\"console1\" description=\"affiche \">");
        buffer.append("<USE_PERSISTENCE value=\"NO\" />");
        buffer.append("<FROM link=\"console\">");
        buffer.append("<PRIORITY value=\"1\" />");
        buffer.append("<DECODER ");
        buffer.append("value=\"com.francetelecom.odis.testModel.TensionEncoderDecoder\" />");
        buffer.append("</FROM>");
        buffer.append("<ENGINE_PROCEED>");
        buffer.append("<PROCESS");
        buffer.append(" value=\"com.francetelecom.odis.component.test.ProcessGetTension\" />");
        buffer.append("<PROPERTIES value=\"\" />");
        buffer.append("</ENGINE_PROCEED>");
        buffer.append("</NODE>");
        buffer.append("</NODES>");
        buffer.append("<CONNECTIONS>");
        buffer.append("<FIFO name=\"console\"/>");
        buffer.append("</CONNECTIONS>");
        buffer.append("</odis>");
        Domain domain = Domain.getInstance();
        System.out.println("During init() : " + buffer.toString());
        domain.initAndStartByStringLater(buffer.toString());
        return true;
    }

    public void notifyFWEvent(FWEvent event) {
        System.out.println(event);
    }

    public List proceed(Object obj) {
        Domain domain = Domain.getInstance();
        System.out.println(buffer.toString());
        domain.initAndStartByStringLater(buffer.toString());
        return null;
    }
}
