package org.ow2.odis.testModel;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * The Class TensionPeer.
 */
public class TensionPeer extends Tension {
    // ----------------------------------------------------------------------------------------
    // attributes
    // ----------------------------------------------------------------------------------------
    /** The Constant serialVersionUID. */
    private static final long serialVersionUID = 1L;

    /** The value. */
    private int value = 0;

    /** The telephone. */
    private String telephone = "";

    /** The time. */
    private long time = 0;

    /** The id. */
    private long id = 0;

    // ----------------------------------------------------------------------------------------
    // methodes
    // ----------------------------------------------------------------------------------------
    /**
     * To string.
     * @return the string
     * @see org.ow2.odis.testModel.Tension#toString()
     */
    public String toString() {
        StringBuffer buffer = new StringBuffer();
        SimpleDateFormat df = (SimpleDateFormat) SimpleDateFormat.getInstance();
        df.applyPattern("yyyy.MM.dd 'at' HH:mm:ss");
        buffer.append("|");
        buffer.append(id);
        buffer.append("|");
        buffer.append(telephone);
        buffer.append("|");
        buffer.append(df.format(new Date(time)));
        buffer.append("|");
        buffer.append(value);
        buffer.append("|");
        return buffer.toString();
    }

    // ----------------------------------------------------------------------------------------
    // Getter and Setter for each private attribute
    // ----------------------------------------------------------------------------------------
    /**
     * Gets the id.
     * @return the id
     * @see org.ow2.odis.testModel.Tension#getId()
     */
    public long getId() {
        return id;
    }

    /**
     * Sets the id.
     * @param id the id
     * @see org.ow2.odis.testModel.Tension#setId(long)
     */
    public void setId(long id) {
        this.id = id;
    }

    /**
     * Gets the telephone.
     * @return the telephone
     * @see org.ow2.odis.testModel.Tension#getTelephone()
     */
    public String getTelephone() {
        return telephone;
    }

    /**
     * Sets the telephone.
     * @param telephone the telephone
     * @see org.ow2.odis.testModel.Tension#setTelephone(java.lang.String)
     */
    public void setTelephone(String telephone) {
        this.telephone = telephone;
    }

    /**
     * Gets the time.
     * @return the time
     * @see org.ow2.odis.testModel.Tension#getTime()
     */
    public long getTime() {
        return time;
    }

    /**
     * Sets the time.
     * @param time the time
     * @see org.ow2.odis.testModel.Tension#setTime(long)
     */
    public void setTime(long time) {
        this.time = time;
    }

    /**
     * Gets the value.
     * @return the value
     * @see org.ow2.odis.testModel.Tension#getValue()
     */
    public int getValue() {
        return value;
    }

    /**
     * Sets the value.
     * @param value the value
     * @see org.ow2.odis.testModel.Tension#setValue(int)
     */
    public void setValue(int value) {
        this.value = value;
    }
}
